# -------------------------------------------------------------
# Beispiel 4.1
# Anlegen einer zeitgesteuerten Aufgabe
# -------------------------------------------------------------

function Create-ScheduledTask
([string]$ComputerName = "localhost",
 [string]$RunAsUser = "System",
 [string]$TaskName = "TestTask",
 [string]$Schedule = "Tglich",
 [string]$Days = "Mo",
 [string]$StartTime = "03:00",
 [string]$Task)
{
  $CmdLine  = "Schtasks.exe /create /s $ComputerName /ru $RunAsUser "
  $CmdLine += "/tn $TaskName /tr $Task /sc $Schedule /st $StartTime /F"
  Invoke-Expression $CmdLine
  if ($LastExitCode -eq 0)
  { Write-Host -fore green "Task wurde angelegt." }
  else
  { Write-Host -fore red "Fehler ($LastExitCode) beim Anlegen des neuen Tasks" }
}

Create-ScheduledTask -Task "`"PowerShell -File 'C:\PsKurs\HalloSkript.ps1' -NoExit`"" -TaskName PmTask -Schedule Einmal