﻿# -------------------------------------------------------------
# Beispiel 5.2
# Rekursive Suche mit Write-Progress-Anzeige
# -------------------------------------------------------------

function DirRec
($Pfad, $Suchmuster)
{ 
 Get-ChildItem -Path $Pfad\$Suchmuster -Name -outvariable Res
 $Script:Treffer += @($Res).Count
 Get-ChildItem -Path $Pfad -ErrorAction SilentlyContinue | Where-Object { $_.PsIsContainer } | `
  Foreach-Object { Write-Debug "Durchsuche $($_.FullName)"
                   $Script:Anzahl++
                   if ($Anzahl -eq 100) { $Script:Anzahl = 0 }
                   Write-progress -Activity ("Suche läuft... {0} Dateien gefunden" -f $Treffer) -Status "Bitte Geduld..:" -PercentComplete $Anzahl
                   DirRec -Pfad $_.FullName\$Suchmuster }
}

$Anzahl = 0
$Treffer = 0
$DebugPreference = "Continue"
DirRec -Pfad $Env:Programfiles -Suchmuster *.vbs
Write-Host "$Treffer Dateien gefunden"
$DebugPreference = "SilentlyContinue"
