﻿# -------------------------------------------------------------
# Beispiel 5.3
# Auflisten der Berechtigungen eines Benutzers
# -------------------------------------------------------------

function Get-ACLUser
{
 param([string]$UserName, [string]$Pfad)
 if (!(test-path $Pfad))
 { Write-Host -fore red "$Pfad ist kein gültiger Pfad";return }
 $ACLs = Get-Acl $Pfad | Select-Object -exp Access | Where-Object { $_.IdentityReference -like "*\$UserName" }
 $Allows = @($ACLs | Where-Object { $_.AccessControlType -eq "Allow" })
 $Denys = @($ACLs | Where-Object { $_.AccessControlType -eq "Deny" })
 Write-Host -fore Green "Berechtigungen vom Typ 'Zulassen' für $Pfad"
 $Allows | Foreach-Object { ">$($_.FileSystemRights)" } 
 Write-Host -fore Green "$($Allows.Count) Berechtigung(en)."
 Write-Host -fore Magenta "Berechtigungen vom Typ 'Verweigern' für $Pfad"
 $Denys | Foreach-Object { ">$($_.FileSystemRights)" } 
 Write-Host -fore Magenta "$($Denys.Count) Berechtigung(en)."
}

Get-ACLuser -UserName Admin* -Pfad C:\Windows

