﻿# -------------------------------------------------------------
# Beispiel 5.5
# Setzen der Zugriffsberechtigungen für einen Ordner
# -------------------------------------------------------------
# Folgende Parameter werden benötigt:
# 1) Benutzerkonto
# 2) Art der Berechtigung - Lesen/Schreiben/Keine
# 3) Ordnerpfad
# -------------------------------------------------------------
# Die Zugriffssteuerung ist Allow
# -------------------------------------------------------------

function Set-CustAcl
{
  param ([string]$Benutzer, [string]$Zugriffsmodus, [string]$Pfad, [bool]$Vererbung=$false)
  [string]$AcMode = "None"
  switch ($Zugriffsmodus)
  {
    "Lesen"     { $AcMode = "Read" }
    "Schreiben" { $AcMode = "Write" }
    "Keine"     { $AcMode = "None" }
  }
  $ACL = Get-Acl $Pfad -ErrorAction SilentlyContinue
  if (!$?)
  { write-host "$Pfad gibt es nicht - Funktion wird beendet";return }
  # Soll Regel an Unterordner und Dateien weitervererbt werden?
  # Propagation soll keine Rolle spielen
  if (!$Vererbung)
  {
   $Perm = "$Env:UserDomain\$Benutzer", $AcMode, "None", "None", "Allow"
  }
  else
  {
   $Perm = "$Env:UserDomain\$Benutzer", $AcMode, "ObjectInherit,ContainerInherit", "None", "Allow"
  }
  $ACRule = new-object System.Security.AccessControl.FileSystemAccessRule $Perm
  $ACL.SetAccessRule($ACRule)
  $ACL | Set-Acl $Pfad # -ErrorAction SilentlyContinue
  if ($?)
  { write-host -fore green "Zugriffsberechtigungen wurde ergänzt." }
  else
  { write-host -fore yellow "Es gab leider ein Problem beim Setzen der Zugriffsberechtigungen."}
}
