﻿# --------------------------------------------------
# Beispiel 5.7
# Besitzer für ein Verzeichnis setzen
# -------------------------------------------------------------
# Setzt die PowerShell Community Extensions 1.1/1.2 voraus
# -------------------------------------------------------------
# Ist nur einmal erforderlich
Write-Host -fore yellow "Prüfe auf PSCX - bitte etwas Geduld..."
if ((Get-Pssnapin | Where-Object { $_.Name -eq "PSCX" }) -eq $null) {
# Versuch sie nachzuladen
  Add-Pssnapin -Name PSCX -ErrorAction SilentlyContinue
  if ($?)
  { Write-Verbose "Die PSCX wurden nachgeladen" }
  else
  { Write-Host -fore red "PSCX konnten nicht geladen werden - Skript wird beendet";break}
}
$TokPriv = New-Object Pscx.Interop.TokenPrivilege "SeRestorePrivilege", $true
Set-Privilege $TokPriv
$DateiPfad = $Env:Userprofile+"\ACLTest"
$ACL =  (Get-Acl $DateiPfad)
$NewOwnerName = "Pemo09"
$NewOwnerAccount = New-Object Security.Principal.NTAccount($NewOwnerName)
# Benutzerobjekt überprüfen
$NewOwnerSid = $NewOwnerAccount.Translate([System.Security.Principal.SecurityIdentifier])
$ACL.SetOwner($NewOwnerAccount)
Set-Acl -Path $DateiPfad -AclObject $ACL -ErrorAction SilentlyContinue
if ($?)
{ Write-Host -fore green "Besitzer für $DateiPfad wurde auf $NewOwnerName gesetzt". }
else
{ Write-Host -fore red "Besitzer konnte nicht auf $NewOwnerName gesetzt werden." }
