﻿# -------------------------------------------------------------
# Beispiel 5.8
# Besitzer via WMI setzen
# -------------------------------------------------------------
function Set-OwnerWMI
($UserName, $Pfad)
{
 if (!(Test-Path $Pfad)) {Write-Warning "Ungültiger Pfad"}
 else {
  # Pfad muss für WMI ein wenig angepasst werden
  $Pfad = $Pfad.Replace("\", "\\")
  $SD = ([WMIClass]"Win32_SecurityDescriptor").CreateInstance()
  $Trustee = ([WMIClass]"Win32_Trustee").CreateInstance()
  $SID = (New-Object Security.Principal.NtAccount $UserName).Translate([Security.Principal.SecurityIdentifier])
  [byte[]] $SIDArray = ,0 * $SID.BinaryLength
  $SID.GetBinaryForm($SIDArray,0)
  $Trustee.Name = $UserName
  $Trustee.SID = $SIDArray
  $SD.Owner = $Trustee
  $SD.ControlFlags="0x8000"
  $wPrivilege = Get-WmiObject -Class Win32_LogicalFileSecuritySetting -Filter "Path='$Pfad'"
  $wPrivilege.psbase.Scope.Options.EnablePrivileges = $true
  $Ret = $wPrivilege.SetSecurityDescriptor($SD)
  if ($Ret.ReturnValue -eq 0)
  { Write-Host "Setzen des Besitzers auf $UserName war erfolgreich."}
  else
  { Write-Host "Fehler beim Setzen des neuen Besitzers - Fehlercode: $($Ret.ReturnValue)" }
 }
}
