# -------------------------------------------------------------
# Beispiel 6.1
# Logfile-Auswertung mit eigenem Objekt pro Match
# -------------------------------------------------------------
$LogfilePfad = Join-Path -Path (Split-Path -Path $MyInvocation.MyCommand.Path -Parent) -ChildPath Logs\Logfile.log
$RegMuster = "(?<Nr>[0-9]{5})\s+(?<Server>\w+)\s+(?<IP>[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3})\s+Error\s+(?<Msg>[\w ]+)\s+(?<Datum>[0-9]{2}\.[0-9]{2}\.[0-9]{4})"
$MatchListe = @()
Get-Content $LogfilePfad | Foreach-Object {
    $M = [Regex]::Match($_, $RegMuster)
    if ($M.Success)
    {
        $Mo = New-Object PsObject
        $Mo | Add-Member -Name "Datum" -MemberType Noteproperty -Value $M.Groups["Datum"].Value
        $Mo | Add-Member -Name "IP" -MemberType Noteproperty -Value $M.Groups["IP"].Value
        $Mo | Add-Member -Name "Server" -MemberType Noteproperty -Value $M.Groups["Server"].Value
        $Mo | Add-Member -Name "Meldung" -MemberType Noteproperty -Value $M.Groups["Msg"].Value
        $MatchListe += $Mo
    }
}

$MatchListe


