# -------------------------------------------------------------
# Beispiel 8.7
# Touch-Item-Funktion mit Hilfe
# -------------------------------------------------------------

function Touch-Item
{
<#
.Synopsis
 Setzt den Zeitpunkt des letzten Zugriffs
.Description
Setzt den Zeitpunkt des letzten Zugriffs auf den angegebenen Datum/Zeit-Wert
.Parameter Path
 Der Pfad der Datei, deren letzter Zeitpunkt des Zugriffs gesetzt werden soll
.Parameter NewLastAccessTime
 Der neue Zeitpunkt des letzten Zugriffs auf die Datei
.Example
 PS> Touch-Item -Path C:\TestDatei.txt -NewLastAccessTime (Get-Date 1.1.2000)
.Example
 PS> Get-Item C:\TestDatei.txt | Touch-Item -NewLastAccessTime (Get-Date 1.1.2000)
.Link
    Get-Date
.Notes
NAME:      Touch-Item
AUTHOR:    Pemo
LASTEDIT:  25/11/2009
#>
    param([Parameter(Mandatory=$true, ValueFromPipeline=$true)]
            [String]$Path,
            [DateTime]$NewLastAccessTime=(Get-Date)
          )
        (Get-Item -Path $Path).LastAccessTime = $NewLastAccessTime
}
