# -------------------------------------------------------------
# Beispiel 8.10
# Anlegen eines AD-Users und Hinzufgen zu einer Grupe
# Fehlerbehandlung mit try/catch
# -------------------------------------------------------------
$VerbosePreference = "Continue"
$GruppenName = "Autorengruppe"
try
{
    $Pw = Read-Host "Kennwort?" -AsSecure
    Connect-Qadservice -Service <Servername> -ConnectionAccount "<Domainname>\Administrator" -ConnectionPassword $Pw | Out-Null
    Write-Verbose "Verbindung hergestellt."
    New-Qaduser -Name "Bill Tor"  -department "EDV" -Parentcontainer "DC=<Servername>,DC=de" -SamAccountName "BillT" | Out-Null
    Write-Verbose "AD-Benutzer wurde angelegt."
    Get-QadUser "Bill Tor" | Add-QadgroupMember $GruppenName | Out-Null
    Write-Verbose "AD-Benutzer wurde zur Gruppe '$GruppenName' hinzugefgt."
}
catch
{
  "Es trat ein Fehler auf - $_"
}
finally
{
   "Fertig..."
}
