# -------------------------------------------------------------
# Beispiel 9.6
# Gerte auflisten, die einen bestimmten Interrupt benutzen - Variante 2
# -------------------------------------------------------------
$PnpGeraeteListe = @()

for ($IRQNr=1;$IrqNr-le16;$IrqNr++)
{
    "Prüfe Interrupt: $IRQNr"
    $Geraet = New-Object -Type PsObject
    $Geraet | Add-Member -Membertype NoteProperty -Name InterruptNr -Value $IRQNr
    try
    {
      $IRQ = [WMI]"Win32_IRQResource.IRQNumber=$IRQNr"
      $PnpGeraete = Get-WmiObject -Query "Associators Of {Win32_IRQResource.IRQNumber='$($IRQ.IRQNumber)'} Where ResultClass=Win32_PnpEntity"
      if ($PnpGeraete -ne $null)
      {
        $PnpGeraeteNamen = @()
        foreach($PnpGeraet In $PnpGeraete)
        {
          $PnpGeraeteNamen += $PnpGeraet.Name
        }
        $Geraet | Add-Member -Membertype NoteProperty -Name Anzahl -Value $PnpGeraeteNamen.Length
        $Geraet | Add-Member -Membertype NoteProperty -Name Geraete -Value ($PnpGeraeteNamen -Join ",")
      }
     }
     catch
     {
       $Geraet | Add-Member -Membertype NoteProperty -Name Anzahl -Value 0
       $Geraet | Add-Member -Membertype NoteProperty -Name Geraete -Value "Keine Gerte"
       Write-Host -Fore White -Back Red "Fehler beim Zugriff auf Win32_IRQResource und Interrupt $IRQNr"
     }
     $PnpGeraeteListe += $Geraet
 }
$PnpGeraeteListe | Format-Table –Auto
