# -------------------------------------------------------------
# Beispiel 9.7
# WLAN-Adapter zurcksetzen
# -------------------------------------------------------------

function Reset-Adapter
($Adapter)
{
  # Rückgabewert muss 0 sein, wenn Aufruf erfolgreich war
  $Ret = ($Adapter.Disable()).ReturnValue
  # Ein wenig warten (willkürliche Zeitspanne)
  Start-Sleep -Seconds 2
  # Rckgabewert muss 0 sein, wenn Aufruf erfolgreich war
  $Ret = ($Adapter.Enable()).ReturnValue
  "WLAN-Adapter '$($Adapter.Name)' wurde zurckgesetzt."
}

$WLANAdapter = Get-WmiObject -Class Win32_NetworkAdapter -Filter "Name Like '%wireless%'"
# Gibt es nur einen WLAN-Adapter?
if ($WLANAdapter.Count -eq $null)
{
    Reset-Adapter -Adapter $WLANAdapter
}
# Gibt es mehrere, dann Auswahl anbieten
else
{
  $AnzahlAdapter = 1
  $WLANAdapter | Foreach-Object {
   "$AnzahlAdapter) $($_.Name)"
   $AnzahlAdapter++
  }
  $AdapterNr = Read-Host -Prompt "Nr. des Adapters (1-$AnzahlAdapter)"
  Reset-Adapter -Adapter $WLANAdapter[$AdapterNr]  
}

