# -------------------------------------------------------------
# Beispiel 9.13
# WMI-Events mit der PowerShell auswerten
# Warten auf das Starten eines bestimmten Prozesses
# -------------------------------------------------------------
# Event gegebenenfalls entregistrieren
# -------------------------------------------------------------
try
{
  Unregister-Event ProzStarted -ErrorAction Stop
}
# Hier soll nichts passieren
catch {}
# Event eventuell entfernen
Remove-Event -SourceIdentifier ProzStarted -EA SilentlyContinue

# Liste der "verbotenen" Prozesse
$ProzListe = @("calc.exe", "freecell.exe", "solitaire.exe", "sol.exe")

# Event registrieren
Register-WmiEvent -Class Win32_ProcessStartTrace -SourceIdentifier ProzStarted

"Warte auf Event..."

# Warten, dass das Event eintritt
$Ev = Wait-Event -SourceIdentifier ProzStarted

# Event trat ein- jetzt die Details holen
$P = $Ev.SourceEventArgs.NewEvent
"Prozess: $($P.ProcessName) ID: $($P.ProcessID)"

# Prfen, ob es ein unerlaubter Prozess war
if ($ProzListe -match $Ev.SourceEventArgs.NewEvent.ProcessName)
{ "$($Ev.SourceEventArgs.NewEvent.ProcessName) darf leider nicht gestartet werden..."}


