# -------------------------------------------------------------
# Beispiel 9.14
# WMI-Events mit der PowerShell auswerten
# berwachen eines Registry-Schlssels
# -------------------------------------------------------------
# Event gegebenenfalls entregistrieren
# -------------------------------------------------------------
try
{
  Unregister-Event RegWatch -ErrorAction Stop
}
# Hier soll nichts passieren
catch {}
# Event eventuell entfernen
Remove-Event -SourceIdentifier RegWatch -EA SilentlyContinue

$RegPfad = "Software\\PowerShellCrashKurs"
$RegQuery = "Select * From RegistryKeyChangeEvent Where Hive='HKey_Local_Machine' `
 And KeyPath='$RegPfad'"
# Event registrieren
Register-WmiEvent -Query $RegQuery -SourceIdentifier RegWatch
Write-Host -fore green -back black "WMI-Event wurde registriert."
Write-Host -fore green -back black "Warte auf Event..."
# Auf das Event warten
$Ev = Wait-Event -SourceIdentifier RegWatch
# Event trat ein - alle Details anzeigen
Write-Host -fore green -back black "Event trat ein..."
$Ev.SourceEventArgs.NewEvent | Format-Table Hive,KeyPath, `
 @{Label="Zeitpunkt";Expression={[DateTime]::FromFileTime($_.Time_Created)}}
