﻿# -------------------------------------------------------------
# Beispiel 10.7
# Eine neue AD-Gruppe anlegen
# -------------------------------------------------------------

$ADS_GROUP_TYPE_GLOBAL_GROUP = 0x00000002
$ADS_GROUP_TYPE_LOCAL_GROUP = 0x00000004
$ADS_GROUP_TYPE_DOMAIN_LOCAL_GROUP = 0x00000004
$ADS_GROUP_TYPE_UNIVERSAL_GROUP = 0x00000008
$ADS_GROUP_TYPE_SECURITY_ENABLED = 0x80000000

function New-pADGroup
([string]$GroupName,
 [string]$ContainerPfad,
 [string]$Description,
 [int32]$GroupType=$ADS_GROUP_TYPE_LOCAL_GROUP
)
{
    $ADContainer = [ADSI]"LDAP://$ContainerPfad"
  try
  {
   $ADGroup = $ADContainer.Create("group","CN=$GroupName")
   # Direkte Zuweisung an SAMAccountName ist nicht möglich
   $ADGroup.InvokeSet("SAMAccountName", $GroupName)
   $ADGroup.psbase.CommitChanges()
   "Gruppe wurde angelegt."
  }
  catch
  { 
    Write-Host -Fore White -Back Red "Gruppe konnte nicht angelegt werden. ($_)"
    break
  }
}
