# -------------------------------------------------------------
# Beispiel 10.11
# AD-Gruppen rekursiv durchlaufen
# -------------------------------------------------------------
$Level = 0

function Get-AllGroupMembers
($Gruppe)
{
  $Level++
  "$(new-object string "*",$Level) Gruppe $($Gruppe.DistinguishedName)"
  # Alle Members durchgehen
  if ($Gruppe.member.count -gt 0)
  {
   $Gruppe.member | Foreach-Object {
    $en = [ADSI]"$_"
    if ($en.objectClass[1] -ne "Group")
    {
       "$(new-object string "-",$Level)>Member $_"
    }
   }
   $Gruppe.member | Foreach-Object {
    $en = [ADSI]"$_"
    # Der 2. Eintrag ist die Objektklasse (z.B. group)
    if ($en.objectClass[1] -eq "group")
    {
       Get-AllGroupMembers -Gruppe $en
    }
  }
 }
 $Level--
}

$Gr = [ADSI]"CN=TestGruppe, CN=Users, DC=Pemobooks, DC=de"
Get-AllGroupMembers -Gruppe $Gr
