# -------------------------------------------------------------
# Beispiel 10.12
# Eine neue Organisationseinheit anlegen
# -------------------------------------------------------------

function New-pADOU
([string]$ContainerPfad,
 [string]$OUName,
 [string]$Description="Noch keine Beschreibung")
{
  try
  {
     $ADContainer = [ADSI]"LDAP://$ContainerPfad"
     $OUNeu = $ADContainer.Create("organizationalUnit", "OU=$OUName")
     $OUNeu.CommitChanges()
     $OUNeu.Description = $Description
     $OUNeu.CommitChanges()
     "OU wurde angelegt." 
  }
  catch
  {
     Write-Host -Fore White -Back Red "OU konnte nicht angelegt werden. ($_)"
  }
}

New-pADOU -ContainerPfad "DC=Pemobooks, DC=local" -OUName "TestOU"
