﻿# -------------------------------------------------------------
# Beispiel 10.22
# Alle Domänen in einem Forest auflisten
# -------------------------------------------------------------
function Get-ForestDomains
(
 [switch]$Lokal,
 [string]$Servername=$(throw "Bitte Servername angegeben..."),
 [string]$Benutzername,
 [System.Security.SecureString]$Kennwort
)
{
 if ($Lokal)
 {
   $Forest = [System.DirectoryServices.ActiveDirectory.Forest]::GetCurrentForest()
 }
 else
 {
   $Dc = Get-DCContext -Servername $ServerName -Benutzername $Benutzername -Kennwort $Kennwort
   try
   {
     $Forest = [System.DirectoryServices.ActiveDirectory.Forest]::GetForest($Dc) 
     $Forest.Domains | Foreach-Object {
      "Domäne: $($_.Name) - Modus: $($_.DomainMode)"
      }
   }
   catch
   {
     Write-Host -Back White -fore Red "Fehler - kein Zugriff auf Domäne/Forest"
   }
 }
}
