# -------------------------------------------------------------
# Beispiel 12.1
# Anlegen einer Verknfung auf eine PowerShell-Skriptdatei
# -------------------------------------------------------------

function New-PS1Shortcut
($Skriptpfad)
{
  $SkriptName = Split-Path -Path $Skriptpfad -Leaf
  # Erweiterung abtrennen
  $SkriptName = $SkriptName -split ".ps1"
  try
  {
    $Wsh = New-Object -Com WScript.Shell
    $Sh = $Wsh.CreateShortcut("$Env:Userprofile\Desktop\$Skriptname.lnk")
    $Sh.TargetPath = $PsHome+"\PowerShell.exe"
    # Muss nicht unbedingt gesetzt werden
    $Sh.WorkingDirectory = Split-Path -Path $Skriptpfad
    # wichtig: Hier wird das auszufhrende Skript festgelegt
    $Sh.Arguments = "-Noprofile -File $SkriptPfad"
    # Ebenfalls optional
    $Sh.Hotkey = "ALT+CTRL+M"
    # Verknpfung wird durch das Speichern erst angelegt
    $Sh.Save()
    Write-Debug "Shortcut wurde angelegt."
  }
  catch
  {
    Write-Host -Fore White -Back Red "Shortcut konnte nicht angelegt werden. ($_)"
  }
}

$DebugPreference = "Continue"
New-Ps1Shortcut -SkriptPfad C:\PsKurs\MessageboxShow.ps1
$DebugPreference = "SilentlyContinue"

