# -------------------------------------------------------------
# Beispiel 12.2
# Inhalt einer Msi-Datei auflisten
# -------------------------------------------------------------
# Funktioniert nur, wenn Type-Datei zuvor geladen wurde
# -------------------------------------------------------------

function Get-MsiContent
([string]$MsiPfad)
{
  # Gibt es die Msi-Datei?
  if (!(Test-Path -Path $MsiPfad))
  {
    Write-Host -Fore White -Back Red "Msi-Datei nicht gefunden. ($MsiPfad)"
    break
  }
  $OpenDatabaseModeReadOnly = 0
  try
  {
   $Msi = New-Object -Com WindowsInstaller.Installer
  }
  catch
  {
      Write-Host -Fore White -Back Red "Die Msi-Komponente konnte nicht angesprochen werden. ($_)"
      break
  }
  $MsiDb = $Msi.InvokeMethod("OpenDatabase", $MsiPfad, $OpenDatabaseModeReadOnly)
  $MsiView = $MsiDb.InvokeMethod("OpenView", "Select FileName, FileSize From File") 
  $MsiView.InvokeMethod("Execute")
  while ($true)
  {
    $MsiRecord = $MsiView.InvokeMethod("Fetch")
    if ($MsiRecord -eq $null) { break }
      $FileName = $MsiRecord.InvokeParamProperty("StringData", 1).Split("|")[1]
      $FileSize = $MsiRecord.InvokeParamProperty("StringData", 2)
      Write-Host -fore green "Datei: $FileName, Größe: $FileSize"
  }
}
