﻿# -------------------------------------------------------------
# Beispiel 12.3
# Anlegen einer neuen SQL Server Compact-Datenbank
# -------------------------------------------------------------
# Pfad der Sdf-Datei muss angepasst werden
# -------------------------------------------------------------
$DebugPreference = "Continue"

$DBPfad = "C:\PsKurs\LoginsDB.sdf"
$CnSt = "Data Source=$DBPfad"
# Zuerst die Datenbankdatei selber anlegen
try
{
 if (Test-Path $DBPfad)
 { Remove-Item $DBPfad }
}
catch
{
    Write-Host -Fore White -Back Red "Datenbankdatei konnte nicht gelöscht werden. ($_)"
    break
}

try
{
    [System.Reflection.Assembly]::LoadWithPartialName("System.Data.SqlServerCe") | Out-Null
    $Db = New-Object System.Data.SqlServerCe.SqlCeEngine $CnSt
    $Db.CreateDatabase()
    Write-Debug "Datenbankdatei wurde angelegt."
}
catch
{
    Write-Host -Fore White -Back Red "Datenbankdatei konnte nicht angelegt werden. ($_)"
    break
}

# Jetzt die Logins-Tabelle anlagen
try
{
   $Cn = New-Object System.Data.SqlServerCe.SqlCeConnection $CnSt
   $Cn.Open()
   $Sql = @"
        CREATE TABLE Logins(
         LoginID int NOT null CONSTRAINT LoginID_PK PRIMARY KEY Identity,
         UserID int,
         LoginDate DateTime)
"@
   $Cmd = $Cn.CreateCommand()
   $Cmd.CommandText = $Sql
   $ret = $Cmd.ExecuteNonQuery()
   Write-Debug "Tabelle Logins wurde angelegt."
}
catch
{
    Write-Host -Fore White -Back Red "Tabelle Logins konnte nicht angelegt werden. ($_)"
}
# Verbindung wieder beenden
finally
{
    $Cn.Close()
}

# Jetzt die Users-Tabelle anlegen
try
{
   $Cn = New-Object System.Data.SqlServerCe.SqlCeConnection $CnSt
   $Cn.Open()
   $Sql = @"
        CREATE TABLE Users(
         UserID int NOT null CONSTRAINT UserID_PK PRIMARY KEY Identity,
         UserName nvarchar(40))
"@
   $Cmd = $Cn.CreateCommand()
   $Cmd.CommandText = $Sql
   $ret = $Cmd.ExecuteNonQuery()
   Write-Debug "Tabelle Users wurde angelegt."
}
catch
{
    Write-Host -Fore White -Back Red "Tabelle User konnte nicht angelegt werden. ($_)"
}
# Verbindung wieder beenden
finally
{
    $Cn.Close()
}
