﻿# -------------------------------------------------------------
# Beispiel 12.4
# Datensätze in eine SQL Server-Compact-Datenbank einfügen
# -------------------------------------------------------------
# Pfad der Sdf-Datei muss angepasst werden
# -------------------------------------------------------------

# -------------------------------------------------------------
# Neuen User in der Users-Tabelle anlegen
# -------------------------------------------------------------
function New-UserEntry
($UserName)
{
    $DBPfad = "C:\PsKurs\LoginsDB.sdf"
    try
    {
     [System.Reflection.Assembly]::LoadWithPartialName("System.Data.SqlServerCe") | Out-Null
    }
    catch
    {
        Write-Host -Fore White -Back Red "SQLCE-Provider konnte nicht geladen werden. ($_)"
        break
    }

    try
    {
      # Verbindung herstellen und öffnen
      $Cn = New-Object System.Data.SqlServerCe.SqlCeConnection $CnSt
      $Cn.Open()
      # Feststellen, ob es Benutzer bereits gibt - keine Apostrophe im SQL-Kommando!
      $Sql = "Select UserID From Users Where UserName=@UserName"
      # Command-Objekt für die Abfrage anlegen
      $Cmd = $Cn.CreateCommand()
      $Cmd.CommandText = $Sql
      $Cmd.Parameters.AddWithValue("@UserName", $UserName) | Out-Null
      $ret = $Cmd.ExecuteScalar()
      if ($ret -ne $null)
      { Write-Debug "Benutzer existiert bereits." }
      else
      {
          $Cmd = $Cn.CreateCommand()
          $Sql = "Insert Into Users (Username) Values(@UserName)"
          $Cmd.CommandText = $Sql
          $Cmd.Parameters.AddWithValue("@UserName",$UserName) | Out-Null
          # Befehl ausführen
          $ret = $Cmd.ExecuteNonQuery()
          if ($ret -eq 1)
          { Write-Debug "Datensatz wurde eingefügt." }
          else
          {  Write-Debug "Datensatz wurde nicht eingefügt `$Ret=$Reg." }
       }
      }
      catch
      {
         Write-Host -Fore White -Back Red "Fehler beim Zugriff auf die Datenbank. ($_)"
      }
      # Verbindung wieder beenden
      finally
      {
        $Cn.Close()
      }
}

# -------------------------------------------------------------
# Neuen Eintrag in der Logins-Tabelle anlegen
# -------------------------------------------------------------
function New-LoginEntry
($UserName)
{
    $DBPfad = "C:\PsKurs\LoginsDB.sdf"
    try
    {
     [System.Reflection.Assembly]::LoadWithPartialName("System.Data.SqlServerCe") | Out-Null
    }
    catch
    {
        Write-Host -Fore White -Back Red "SQLCE-Provider konnte nicht geladen werden. ($_)"
        break
    }
    # Jetzt die Logins-Tabelle anlegen
    try
    {
      $Cn = New-Object System.Data.SqlServerCe.SqlCeConnection $CnSt
      $Cn.Open()
      $Cmd = $Cn.CreateCommand()
      # User-ID abfragen - ohne Apostrophe
      $Sql = "Select UserID From Users Where UserName=@UserName"
      $Cmd.CommandText = $Sql
      $Cmd.Parameters.AddWithValue("@UserName", $UserName) | Out-Null  
      $UserID = $Cmd.ExecuteScalar()
      if ($UserID -eq $null)
      {
        Write-Debug "Benutzer existiert nicht - Skript wird beenden."
        break
      }
      # Jetzt Datensatz einfügen
      $Sql = "Insert Into Logins (UserID, LoginDate) Values(@UserID,@LoginDate)"
      $Cmd = $Cn.CreateCommand()
      $Cmd.CommandText = $Sql
      $Cmd.Parameters.AddWithValue("@UserID",$UserID) | Out-Null
      $Cmd.Parameters.AddWithValue("@LoginDate", (Get-Date)) | Out-Null
      $ret = $Cmd.ExecuteNonQuery()    
      if ($ret -eq 1)
      { 
        Write-Debug "Datensatz wurde eingefügt."
      }
      else
      {
        Write-Debug "Datensatz wurde nicht eingefügt `$Ret=$Reg."
      }
    }
    catch
    {
      Write-Host -Fore White -Back Red "Fehler beim Zugriff auf die Datenbank. ($_)"
    }
    # Verbindung wieder beenden
    finally
    {
      $Cn.Close()
    }

# -------------------------------------------------------------
# Neuen Eintrag in der Logins-Tabelle anlegen
# -------------------------------------------------------------
function New-LoginEntry
($UserName)
{
    $DBPfad = "C:\PsKurs\LoginsDB.sdf"
    try
    {
     [System.Reflection.Assembly]::LoadWithPartialName("System.Data.SqlServerCe") | Out-Null
    }
    catch
    {
        Write-Host -Fore White -Back Red "SQLCE-Provider konnte nicht geladen werden. ($_)"
        break
    }
    # User-ID abfragen
    $Sql = "Select UserID From Users Where UserName='$UserName'"
    # Jetzt die Logins-Tabelle anlegen
    try
    {
      $Cn = New-Object System.Data.SqlServerCe.SqlCeConnection $CnSt
      $Cn.Open()
      $Cmd = $Cn.CreateCommand()
      $Cmd.CommandText = $Sql
      $UserID = $Cmd.ExecuteScalar()

      # Jetzt Datensatz einfügen
      $Sql = "Insert Into Logins (UserID, LoginDate) Values(@UserID,@LoginDate)"
      $Cmd = $Cn.CreateCommand()
      $Cmd.CommandText = $Sql
      $Cmd.Parameters.AddWithValue("@UserID",$UserID) | Out-Null
      $Cmd.Parameters.AddWithValue("@LoginDate", (Get-Date)) | Out-Null
      $ret = $Cmd.ExecuteNonQuery()    
      if ($ret -eq 1)
      { 
        Write-Debug "Datensatz wurde eingefügt."
      }
      else
      {
        Write-Debug "Datensatz wurde nicht eingefügt `$Ret=$Reg."
      }
    }
    catch
    {
      Write-Host -Fore White -Back Red "Fehler beim Zugriff auf die Datenbank. ($_)"
    }
    # Verbindung wieder beenden
    finally
    {
      $Cn.Close()
    }
  }
}
