# -------------------------------------------------------------
# Beispiel 12.6
# Abfrage der LoginsDB-Datenbank
# -------------------------------------------------------------
# Pfad der Sdf-Datei muss angepasst werden
# -------------------------------------------------------------

# -------------------------------------------------------------
# Alle Einträge aus der Logins-Tabelle für einen User
# -------------------------------------------------------------
function Get-UserEntry
([string]$UserName,
 [string]$Startzeit,
 [string]$Endezeit)
{
    $DBPfad = "C:\PsKurs\LoginsDB.sdf"
    try
    {
     [System.Reflection.Assembly]::LoadWithPartialName("System.Data.SqlServerCe") | Out-Null
    }
    catch
    {
        Write-Host -Fore White -Back Red "SQLCE-Provider konnte nicht geladen werden. ($_)"
        break
    }

    try
    {
      # Verbindung herstellen und öffnen
      $Cn = New-Object System.Data.SqlServerCe.SqlCeConnection $CnSt
      $Cn.Open()
      # Es muss eine Join-Abfrage sein
      $Sql = "Select UserName, LoginDate From Logins 
              Inner Join Users On Logins.UserID = Users.UserID
              Where UserName=@UserName
               And LoginDate > @StartZeit And LoginDate < @EndeZeit"
      # Command-Objekt für die Abfrage anlegen
      $Cmd = $Cn.CreateCommand()
      $Cmd.CommandText = $Sql
      $Cmd.Parameters.AddWithValue("@UserName", $UserName) | Out-Null
      $Cmd.Parameters.AddWithValue("@StartZeit", $StartZeit) | Out-Null
      $Cmd.Parameters.AddWithValue("@EndeZeit", $EndeZeit) | Out-Null
      $Dr = $Cmd.ExecuteReader()
      $ErgebnisListe = @()
      while ($Dr.Read())
      {
        $Zeile = new-object PsObject
        $Zeile | Add-Member -Name "UserName" -Value $Dr.Item("UserName") -MemberType NoteProperty
        $Zeile | Add-Member -Name "LoginZeitpunkt" -Value $Dr.Item("LoginDate") -MemberType NoteProperty
        $ErgebnisListe += $Zeile
      }
      $ErgebnisListe
    }
    catch
    {
       Write-Host -Fore White -Back Red "Fehler beim Zugriff auf die Datenbank. ($_)"
    }
    # Verbindung wieder beenden
    finally
    {
      $Cn.Close()
    }
}

# -------------------------------------------------------------
# Durchführen der Abfrage
# -------------------------------------------------------------
$DebugPreference = "Continue"
$CnSt = "Data Source=$DBPfad"
Get-UserEntry -UserName SusiQ -StartZeit 08.12.2009 -EndeZeit 09.12.2009
$DebugPreference = "SilentlyContinue"
