﻿# -------------------------------------------------------------
# Beispiel 12.7
# Mediendateien über BITS und RSS-Feed laden
# -------------------------------------------------------------

function Get-RSSMediaFiles
($FeedURL)
{
 try
 {
   $Rss = [Xml](new-object System.Net.WebClient).DownloadString($FeedURL)
 }
 catch
 {
    Write-Host -Fore White -Back Red "RSS-Feed konnte nicht geladen werden. ($_)"
    break
 }
 $Rss.Rss.channel.item | Foreach-Object {
  $Enclosure = $_.enclosure
  $Url = New-Object System.Uri $Enclosure.Url
  $UriAbsolut = $Url.AbsoluteUri
  $DownloadFileName = $Url.Segments[-1]
  # Jetzt Datei herunterladen
  if (!(Test-Path $DownloadFileName))
  {
    Write-Debug "Starte Download für $DownloadFileName."
    Start-BitsTransfer -Source $UriAbsolut -Destination $DownloadFileName -TransferType Download -
Asynchronous
  }
  else
  {
    Write-Debug "$DownloadFileName existiert bereits."
  }
 }
}
