﻿# -------------------------------------------------------------
# Beispiel 12.09
# Mail versenden mit System.Net.Mail.MailMessage und Attachements
# -------------------------------------------------------------
function Send-MailEx
([string]$From,
 [string]$To,
 [string]$Subject,
 [string]$Message,
 [string[]]$Attachments,
 [string]$SMTPServer,
 [System.Net.NetworkCredential]$Credential
)
{
  $SMTPClient = New-Object -Type System.Net.Mail.Smtpclient
  $SMTPClient.Host = $SMTPServer
  $SMTPClient.UseDefaultCredentials = $false
  $SMTPClient.Credentials = $Credential
  # Nachricht versenden
  Write-Debug "Sende Nachricht an $To über SMTP-Host $SMTPHost - Port $($SMTPClient.Port)"
  try
  { 
    $MailMessage = New-Object System.Net.Mail.MailMessage $From, $To, $Subject, $Message
    if ($Attachments -ne $null)
    {
     foreach ($At in $Attachments)
     { 
       $MailMessage.Attachments.Add($At)
     }
    }
    $SMTPClient.Send($MailMessage) 
    Write-Debug "Nachricht von $From wurde an $To versandt ($($Attachments.Count) Anhang/Anhänge)."
  } 
  catch
  {
    Write-Host -Fore White -Back Red "Fehler beim Versenden der Nachricht. ($_)"
  }
}

