﻿# -------------------------------------------------------------
# Beispiel 13.6 - Scriptblock als Wert für den Destination-Parameter von Copy-Item
# -------------------------------------------------------------

# Erst das Zielverzeichnis anlegen
$Ps1Pfad = "NoCommmentFilesDir"
if (!(Test-Path $Ps1Pfad))
{
   New-Item -Path $Ps1Pfad -Itemtype Directory | Out-Null
}
Get-ChildItem *.ps1 | Copy-Item -Destination `
 {if ((Get-Content $_.FullName -ReadCount 1) -notlike "#*") 
  {Join-Path $Ps1Pfad $_.Name.Insert($_.Name.LastIndexOf("."), "_Kein Kommentar")}
  else
  { Join-Path $Ps1Pfad $_.Name }
} 

Write-Host -Fore green "$((Get-ChildItem *.ps1).Count) Dateien kopiert."
