# -------------------------------------------------------------
# Beispiel 14.1
# Signieren eines Skripts
# -------------------------------------------------------------
# File: Sign-Script.ps1
# -------------------------------------------------------------

function Sign-Script
(
  [String]$Skriptpfad = $(throw "Pfadangabe der Ps1-Datei erforderlich"),
  $Zert
)
{
  if ($Zert -eq $Null)
  {
    $Zert = @(Get-Childitem cert:\CurrentUser\My -codesigning)[0]
    if ($Zert -eq $Null)
    {
        Write-Host -Fore White -Back Red "Kein Zertifikat zum Signieren vorhanden"
        break
    }
  }
  try
  {
    Set-Authenticodesignature -FilePath $SkriptPfad -Certificate $Zert | Out-Null
    Write-Host "Signieren war erfolgreich."
  }
  catch
  {
     Write-Host -Fore White -Back Red "Fehler beim Signieren ($_)"
  }
}

