# -----------------------------------------------------
# Beispiel 14.3
# Datei verschlüsseln
# -------------------------------------------------------------

function Secure-TextFile
([string]$DateiPfad,
 [string]$Zielpfad)
{
    try
    {
      $Dateiinhalt = (Get-Content -Path $DateiPfad) | Out-String
      $SecContent = ConvertTo-SecureString -String $Dateiinhalt -AsPlainText –Force
      if (!(Test-Path $ZielPfad))
      {
        New-Item -ItemType Directory -Path $Zielpfad | Out-Null
      }
      $ZielDatei = Join-Path -Path $Zielpfad -ChildPath (Split-Path -Path ([System.IO.Path]::ChangeExtension($Dateipfad, "crypt")) -Leaf)
      $SecContentText = ConvertFrom-SecureString -SecureString $SecContent
      Set-Content -Path $Zieldatei -Value $SecContentText
      Write-Debug "Datei wurde verschüsselt  - Zieldatei $ZielDatei"
    }
    catch
    {
         Write-Host -Fore White -Back Red "Fehler bei Verschlüsselung ($_)"
    }
}
