# -------------------------------------------------------------
# Beispiel 16.3 - Ausgabe des Tipp des Tages
# Setzt Quotes.txt in $PsHome voraus
# -------------------------------------------------------------
function Get-Quote
{
  try
  {
   $Quotes = @(Get-Content -Path "$PSHome\Quotes.txt" -Ea Stop)
  }
  catch
  {
    Write-Host -Fore Red -Back White "Quotes.txt nicht gefunden."
    break
  }
  $Quote = $Quotes[(Get-Random -Min 0 -Max $Quotes.Length -SetSeed (Get-Date).Millisecond)]
  $MaxLineLen = 64
  # Lnge soll immer gerade sein
  $QuoteLen = $Quote.Length + 4
  if ($QuoteLen -gt $MaxLineLen)
  { $MaxLineLen = $QuoteLen + 4 }
  $HeadLine = New-Object -Type System.String "*", $MaxLineLen
  $PadSpaceQuoteLen = [System.Math]::Floor(($MaxLineLen - $QuoteLen - 4) / 2)
  $PadSpaceQuote = New-Object -Type System.String " ", $PadSpaceQuoteLen
  $PadSpaceQuoteExtra = New-Object -Type System.String " ",($Quote.Length % 2)
  $StatusLine = "Die aktuelle Uhrzeit: $(Get-Date -Format HH:mm)"
  $PadSpaceStatusLen = ($MaxLineLen - $StatusLine.Length) / 2  4
  $PadSpaceStatus = New-Object -Type System.String " ", $PadSpaceStatusLen
  $PadSpaceStatusExtra = New-Object -Type System.String " ",($StatusLine.Length % 2)
  Write-Host -Fore Green $HeadLine
  Write-Host -Fore Green "****$PadSpaceQuote$Quote$PadSpaceQuote$PadSpaceQuoteExtra****"
  Write-Host -Fore Green "****$PadSpaceStatus$StatusLine$PadSpaceStatus$PadSpaceStatusExtra****"
  Write-Host -Fore Green  $HeadLine
}

Get-Quote
