# -------------------------------------------------------------
# Very Simple PowerShell-Quiz (VSPQ)
# Setzt XML-Datei (PsQuiz001.xml) mit Fragen voraus
# -------------------------------------------------------------
# Die Xml-Datei befindet sich im selben Verzeichnis wie das Skript
$QuizDBPfad = Join-Path -Path (Split-Path $MyInvocation.InvocationName) -Child "PsQuiz001.xml"
# System.Xml.Linq.dll Assembly laden
[System.Reflection.Assembly]::LoadWithPartialName("System.Xml.Linq") | Out-Null
$XDoc = [System.Xml.Linq.XDocument]::Load($QuizDBPfad)
$QuizTitel = $XDoc.Element("Quiz").Attribute("Titel").Value
$QuizLevel = $XDoc.Element("Quiz").Attribute("Level").Value
Write-Host "Willkommen zum Quiz $QuizTitel (Level $QuizLevel)"
$AlleFragen = $XDoc.Descendants("Frage")
$AnzahlRichtig = 0
$AnzahlFragen = 0
$AlleFragen | Foreach-Object {
  $AnzahlFragen++  
  $Frage =  $_.Attribute("Text").Value
  $AntwortRichtig = $_.Attribute("Richtig").Value
  $Frage
  $Antworten = $_.Elements("Antwort")
  $AntwortNr = 0
  $Antworten | Foreach-Object {
    $AntwortNr++
    $Antwort = $_.Attribute("Text").Value
    Write-Host "$AntwortNr) $Antwort"
  }
  $Antwort = Read-Host -Prompt "1-$AntwortNr"
  if ($Antwort -eq $AntwortRichtig)
  { $AnzahlRichtig++ }
}
Write-Host "Von $AnzahlFragen Fragen wurden $AnzahlRichtig Fragen richtig beantwortet."
