# -------------------------------------------------------------
# Beispiel 16.5 - A very simple Game of Life - das geht auch mit der PowerShell
# -------------------------------------------------------------
$AnzahlSpalten = 20
$AnzahlZeilen = 20
$AnzahlGenerationen = 20
$AnzahlMutationen = 1

# Berechnet die Anzahl der Nachbarn pro Zelle
# -------------------------------------------------------------
function Get-Nachbarn
{
 for ($Zeile=0;$Zeile-lt$AnzahlZeilen;$Zeile++)
 {
  for ($Spalte=0;$Spalte-lt$AnzahlSpalten;$Spalte++)
  {
    $AnzahlNachbarn = 0
    # 1. Feld links prfen
    if ($Spalte -gt 0 ) { if ($Spielfeld[$Zeile,($Spalte-1)] -eq $True) {$AnzahlNachbarn++} }
    # 2. Feld links oben prfen
    if ($Zeile -gt 0 -and $Spalte -gt 0) { if ($Spielfeld[($Zeile-1),($Spalte-1)] -eq $True) {$AnzahlNachbarn++} }
    # 3. Feld oben prfen
    if ($Zeile -gt 0) { if ($Spielfeld[($Zeile-1),$Spalte] -eq $True) {$AnzahlNachbarn++} }
    # 4. Feld rechts oben prfen
    if ($Zeile -gt 0 -and $Spalte -lt $AnzahlSpalten-1) { if ($Spielfeld[($Zeile-1),($Spalte+1)] -eq $True) {$AnzahlNachbarn++} }
    # 5. Feld rechts prfen
    if ($Spalte -lt $AnzahlSpalten-1) { if ($Spielfeld[$Zeile,($Spalte+1)] -eq $True) {$AnzahlNachbarn++} }
    # 6. Feld rechts unten prfen
    if ($Zeile -lt $AnzahlZeilen-1 -and $Spalte -lt $AnzahlSpalten-1) { if ($Spielfeld[($Zeile+1),($Spalte+1)] -eq $True) {$AnzahlNachbarn++} }
    # 7. Feld unten prfen
    if ($Zeile -lt $AnzahlZeilen-1) { if ($Spielfeld[($Zeile+1),$Spalte] -eq $True) {$AnzahlNachbarn++} }
    # 8. Feld links unten prfen
    if ($Zeile -lt $AnzahlZeilen-1 -and $Spalte -gt 0) { if ($Spielfeld[($Zeile+1),($Spalte-1)] -eq $True) {$AnzahlNachbarn++} }
    $Nachbarn[$Zeile,$Spalte] = $AnzahlNachbarn
  }
 }
}

# -------------------------------------------------------------
# Nachbau eines Ternren Operators (Idee von Karl Prosser)
# -------------------------------------------------------------
function Invoke-Ternary 
([Scriptblock]$Condition, [Scriptblock]$TruePart, [Scriptblock]$FalsePart)
{
   if (&$Condition)
   { &$TruePart }
   else
   { &$FalsePart }
}

# -------------------------------------------------------------
# Gibt das Spielfeld aus
# -------------------------------------------------------------
function Out-Spielfeld
{
 Write-Host "Generation Nr. $g - Anzahl Lebewesen: $AnzahlLebewesen"
 for ($Zeile=0;$Zeile-lt$AnzahlZeilen;$Zeile++)
 {
  for ($Spalte=0;$Spalte-lt$AnzahlSpalten;$Spalte++)
  {
    ?: -Condition {$Spielfeld[$Zeile,$Spalte] -eq $True} -TruePart {write-host "X" -nonewline} -FalsePart {write-host "." -nonewline}
  }
  Write-Host
 }
}

# -------------------------------------------------------------
# Hier beginnt das Spiel
# -------------------------------------------------------------
Set-Alias -Name ?: -Value Invoke-Ternary -Option AllScope -Description "Der Ternary-Operator von Karl Prosser"
# Spielfeld vorbelegen
$Spielfeld = New-Object Type 'Boolean[,]' $AnzahlZeilen, $AnzahlSpalten
$Spielfeld[2,5] = $True
$Spielfeld[2,6] = $True
$Spielfeld[2,7] = $True
$Spielfeld[3,5] = $True
$Spielfeld[3,6] = $True
$Spielfeld[3,7] = $True
$Spielfeld[4,6] = $True
$g = 0
$AnzahlLebewesen = 0

# Spielfeld ausgeben
Out-Spielfeld

# Die Generationen durchnudeln
for($g=1;$g-lt$AnzahlGenerationen;$g++)
{
  $AnzahlLebewesen = 0
  $Nachbarn = New-Object -Type 'Byte[,]' $AnzahlZeilen, $AnzahlSpalten
  Get-Nachbarn
  for ($Zeile=0;$Zeile-lt$AnzahlZeilen;$Zeile++)
  {
   for ($Spalte=0;$Spalte-lt$AnzahlSpalten;$Spalte++)
   {
    $AnzahlNachbarn = $Nachbarn[$Zeile,$Spalte]
    if($Spielfeld[$Zeile,$Spalte] -eq $true)
    {
     if ($AnzahlNachbarn -ge 2 -and $AnzahlNachbarn -le 3)
     { $Spielfeld[$Zeile,$Spalte] = $True; $AnzahlLebewesen++} 
       else { $Spielfeld[$Zeile, $Spalte] = $false }
      }
    else
    { if ($AnzahlNachbarn -eq 3) { $Spielfeld[$Zeile, $Spalte] = $True;$AnzahlLebewesen++} }
   }
  }
  # Zufalls-Mutationen
  for ($i=0;$i-lt$AnzahlMutationen;$i++)
  {
   do
   {
    $Zeile = (Get-Random -Min 0 -Max $AnzahlZeilen)
    $Spalte = (Get-Random -Min 0 -Max $AnzahlSpalten)
   } until ($Spielfeld[$Zeile, $Spalte] -eq $false)
   $Spielfeld[$Zeile, $Spalte] = $true
  }
  # Is anybody alive out there?
  if ($AnzahlLebewesen -gt 0)
  { Out-Spielfeld }
  else { break }
  Read-Host -Prompt "Weiter mit Taste"
}
